'Declaracin de constantes
Const ForReading = 1, ForWriting = 2, ForAppending = 8
Const DBG=0, INFORMATIONAL=1, ERRO=2, CRITICAL=3
Const TristateUseDefault = -2, TristateTrue = -1, TristateFalse = 0

'Declaracin de variables
intLoggingLevel = ERRO
strDomain = "WORKGROUP"
strBasePath = "c:\Remote-Events_log-retriever\"
'strBasePath = ""
strLastTimeFile = strBasePath & "last-event-time.txt"
strServersFile = strBasePath & "listado-de-servidores.txt"
strLogFile = strBasePath & "log\get_event-log.log"
strEventsCsvFile = strBasePath & "eventos\eventos.csv"
strEventsFile = strBasePath & "Listado-de-eventos.txt"
strUserFile = strBasePath & "user.txt"
strPwdFile = strBasePath & "pwd.txt"
strSecurityEventCodes = Array ()
strLastTime = ""
strComputer = ""
arrLogLevelNames = Array ("DEBUG", "INFORMATIONAL", "ERROR", "CRITICAL")
Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objLogStream = objFSO.OpenTextFile (strLogFile, ForWriting, True)
Set objRegExp = New RegExp

'Funcin de log
Sub logger( category, message )
	If category >= intLoggingLevel Then
		objLogStream.WriteLine(Now & "#" & arrLogLevelNames(category) & "#" & message)
	End if
End sub

'Funcin para la gestin de errores
On Error Resume Next
Sub checkErrors ()
	If Err.Number <> 0 Then
		logger ERRO, strComputer & "#" & Err.Number & "#" & Err.Source & "#" & Err.Description
		Err.Clear
	End If 
End Sub

Set objFileUser = objFSO.OpenTextFile(strUserFile, 1, False)
checkErrors
Set objFilePwd = objFSO.OpenTextFile(strPwdFile, 1, False)
checkErrors
strUser = objFileUser.ReadLine
checkErrors
strPassword = objFilePwd.ReadLine
checkErrors

logger INFORMATIONAL, "Iniciada la recogida de eventos"
'Comprueba la existencia del archivo con el listado de servidores
If not objFSO.FileExists(strServersFile) Then
	logger CRITICAL, "No existe el archivo con el listado de servidores"
	Wscript.Echo "No existe el archivo con el listado de servidores"
	Wscript.Quit 0
end if

'Sobreescribe el archivo de log de eventos
objFSO.CreateTextFile strEventsCsvFile, True
checkErrors
logger DBG, "Creado el archivo de csv para los eventos"
Set objFileEvent = objFSO.GetFile(strEventsCsvFile)
checkErrors
If not objFSO.FileExists(strLastTimeFile) then
	objFSO.CreateTextFile strLastTimeFile, True
end if
Set objFileTime = objFSO.GetFile(strLastTimeFile)
checkErrors

'Objeto para el manejo del tiempo UTC
Set dtmStartDate = CreateObject("WbemScripting.SWbemDateTime")
checkErrors
If objFileTime.Size > 0 then
	'Recoge el tiempo de la ltima sincronizacin del log
	Set objTimeStream = objFileTime.OpenAsTextStream(ForReading, TristateUseDefault)
	checkErrors
	objRegExp.Pattern = "^" & vbNewLine
	Do Until objTimeStream.AtEndOfStream
		strline = objTimeStream.readline
		if strline <> "" Then
			strLastTime = objRegExp.replace (strLastTime & vbNewLine & strLine, "")
		End If
	loop
	checkErrors
	objTimeStream.Close
end if

'Abre el archivo csv de logs
Set objEventStream = objFileEvent.OpenAsTextStream(ForWriting, TristateUseDefault)
checkErrors
'Escribe la lnea de cabecera en el csv
objEventStream.WriteLine "Category, Computer IP, Computer Name, Event Code, Record Number, Source Name, Time Written, Event Type, User, Message"
checkErrors
 
Set objFileServers = objFSO.OpenTextFile(strServersFile,1)
checkErrors
Do Until objFileServers.AtEndOfStream
	strComputer = Replace(objFileServers.ReadLine," ","")
	checkErrors
	Set objRegEx = CreateObject("VBScript.RegExp")
	checkErrors
	objRegEx.Pattern = "(\d{1,3}\.){3}\d{1,3}"
	checkErrors
	if objRegEx.Test(strComputer) Then
		checkErrors
		logger INFORMATIONAL, "Recogiendo eventos del servidor " & strComputer

		'**************************** Conexin a la mquina remota
		'Se utiliza este mtodo porque no estn en el mismo dominio
		Set objSWbemLocator = CreateObject("WbemScripting.SWbemLocator")
		Set objSWbemServices = objSWbemLocator.ConnectServer(strComputer, _
		    "root\cimv2", _
		     strUser, _
		     strPassword, _
		     "MS_409", _
		     "ntlmdomain:" + strDomain)
		
		'Cuando estn integrados en un dominio se prodr usar este mtodo
		'strComputer = "SERVER"
		'Set objWMIService = GetObject("winmgmts:" _
		'    & "{impersonationLevel=impersonate}!\\" _
		'    & strComputer & "\root\cimv2")
		'Set colLoggedEvents = objWMIService.ExecQuery _
		'    ("Select * from Win32_NTLogEvent " _
		'        & "Where Logfile = 'System'")

		If Err.Number <> 0 Then
		'No se puede conectar al servidor
			logger ERRO, strComputer & "#" & Err.Number & "#" & Err.Source & "#Can't connect to server " & Err.Description
			Err.Clear
		else
		'Se ha podido conectar al servidor y se procede a la extraccin de eventos
			objRegExp.Pattern = strComputer & "#([^%]+)%"
			checkErrors
			strWhereClause = ""
			If objRegExp.Test (strLastTime) Then
				'Recoge el tiempo de la ltima consulta de logs para este servidor
				Set objMatches = objRegExp.Execute(strLastTime)
				checkErrors
				strTime = objMatches(0).Submatches(0)
				checkErrors
				logger DBG, "ltima consulta al servidor " & strComputer & ":" & strTime 
				If IsDate(strTime) Then
					'Crea la parte de tiempo de la query a los eventos de windows
					dtmStartDate.SetVarDate strTime, false
					strWhereClause = " and TimeWritten >= '" & dtmStartDate & "'"
				end if
			End If
			intEvents=0
			'Abre el archivo que contiene los logs de eventos, y sus cdigos, que se quieren recoger de cada servidor
			Set objFileEventCodes = objFSO.OpenTextFile(strEventsFile, 1, False)
			checkErrors
			Do Until objFileEventCodes.AtEndOfStream
				strLine = objFileEventCodes.ReadLine
				logger DBG, "Linea del archivo de eventos = " & strLine
				arrEvents = Split(strLine,":")
				logger DBG, "Nmero de eventos a recoger: " & UBound(arrEvents)
				If UBound(arrEvents) >= 1 Then
					strLogCategory = arrEvents(0)
					'Aade los nmeros de log que queremos a la consulta
					strEventsClause = ""
					for i = 1 to UBound(arrEvents) Step 1
						If (UBound(arrEvents) = 1 and arrEvents(1) = "*") Then
						'Queremos todos los eventos del log as que se sale
							exit for
						End If 

						If UBound(arrEvents) = 1 Then
							strEventsClause = " and EventCode = '" & arrEvents(i) & "'"		
							Exit For
						End If

						If i = 1 then
							strEventsClause = strEventsClause & " and ("
						else
							strEventsClause = strEventsClause & " or "
						end if

						strEventsClause = strEventsClause & " EventCode = '" & arrEvents(i) & "'"		

						If i = UBound(arrEvents) Then
							strEventsClause = strEventsClause & ")"
						end if
					Next
					'Crea la consulta con los parmetros deseados
					strQuery = "Select * from Win32_NTLogEvent Where Logfile = '" & strLogCategory & "'" & strEventsClause & strWhereClause
					'**************************************************Extraccin de los eventos
					Set colLoggedEvents = objSWbemServices.ExecQuery (strQuery)
					checkErrors
					logger INFORMATIONAL, "Ejecutando la consulta {" & strQuery & "}"
					
					For Each objEvent in colLoggedEvents
						msg = Replace(objEvent.Message,vbNewLine,"#")
						objEventStream.WriteLine objEvent.Category & "," & strComputer & "," & objEvent.ComputerName & "," & objEvent.EventCode & "," & objEvent.RecordNumber & "," & objEvent.SourceName & "," & objEvent.TimeWritten & "," & objEvent.Type & "," & objEvent.User & "," & Replace(msg,vbTab,"")
							'logger DBG, objEvent.Category & "," & objEvent.ComputerName & "," & objEvent.EventCode & "," & objEvent.EventCode & "," & objEvent.RecordNumber & "," & objEvent.SourceName & "," & objEvent.TimeWritten & "," & objEvent.Type & "," & objEvent.User
						intEvents = intEvents + 1 
					Next
				End If
			Loop

			'Si ha recogido eventos almacena la fecha de la ltima ejecucin
			If intEvents > 0 Then
				objRegExp.Pattern = strComputer & ".*%"
				If objRegExp.Test (strLastTime) Then
					strLastTime = objRegExp.replace (strLastTime, strComputer & "#" & Now & "%" ) 
					logger DBG, "Sustituyendo {" & strComputer & ".*%} por {" & strComputer & "#" & Now & "%}"
				Else
					strLastTime = strLastTime & vbNewLine & strComputer & "#" & Now & "%" & vbNewLine
					logger DBG, "Agregando {" & strComputer & "#" & Now & "%}"
				End If
				'Registra el tiempo para evitar recoger eventos ya recogidos
				Set objTimeStream = objFileTime.OpenAsTextStream(ForWriting, TristateUseDefault)
				checkErrors
				objRegExp.Pattern = "^" & vbNewLine
				objTimeStream.WriteLine (objRegExp.replace (strLastTime,""))
				checkErrors
				objTimeStream.Close
			End If
			logger INFORMATIONAL, "Recogidos " & intEvents & " eventos del servidor " & strComputer
			objFileEventCodes.Close
		End If 
	Else
		if strComputer <> " " and strComputer <> "" Then
			logger ERR, "Formato de ip incorrecto para la cadena: " & strComputer
		End If
	End If 
Loop
logger DBG, "Ultima ejecucin realizada " & Now
logger INFORMATIONAL, "Finalizada la recodida de eventos"
'objTimeStream.WriteLine dtmStartDate
objEventStream.Close
objLogStream.Close
